/*
 *
 *  HMG Hyperlink Demo3
 *  Copyright 2005 Roberto Lopez <mail.box.hmg@gmail.com>
 *  http://www.hmgforum.com//
 *  
 *  Revised by Pablo César
 *  Now all URL it's accepting any URL and CodeBlocks is allowed
 *  Changing display color when accessed it
 *  GetProperty for address was fixed
 *
 */

#include "hmg.ch"

Function Main()
LOCAL aItems := {}
LOCAL aImages := { 'C1','C2','C3','C4','C5','C6','C7', 'C8' }

PRIVATE nColor:=1
PRIVATE aColorNow:={ {{000,000,255} , {102,000,153}} ,; // Conventional
                     {{000,000,102} , {153,153,204}} ,; // Blue
                     {{000,102,102} , {153,255,255}} ,; // Cyan
                     {{080,080,080} , {153,153,153}} ,; // Gray
                     {{000,153,000} , {000,051,000}} ,; // Green
                     {{204,000,204} , {102,051,102}} ,; // Margenta
                     {{204,000,000} , {153,051,051}} ,; // Red
                     {{255,255,000} , {153,153,000}} }  // Yellow

AAdd ( aItems , { 1 , "Conventional" } )
AAdd ( aItems , { 2 , "Blue        " } )
AAdd ( aItems , { 3 , "Cyan        " } )
AAdd ( aItems , { 4 , "Gray        " } )
AAdd ( aItems , { 5 , "Green       " } )
AAdd ( aItems , { 6 , "Margenta    " } )
AAdd ( aItems , { 7 , "Red         " } )
AAdd ( aItems , { 8 , "Yellow      " } )

DEFINE WINDOW Main_form ;
    AT 0,0 ;
    WIDTH 646 ;
    HEIGHT 390 ;
    TITLE 'HyperLinks and Labels - Demo3' ;
    MAIN TOPMOST NOSIZE NOMAXIMIZE

    @ 010,015 FRAME Frame_1 CAPTION "HYPERLINKs" WIDTH 300 HEIGHT 280
    
    @ 040,060 MYHYPERLINK H01 VALUE "UPU - Universal Post Union (http)"     ADDRESS 'http://www.upu.int/en/the-upu/member-countries.html' WIDTH 250 HANDCURSOR MYCORRECTION
    @ 070,060 MYHYPERLINK H02 VALUE "EMail by default engine"               ADDRESS 'mailto:someone@example.com'                          WIDTH 250 HANDCURSOR MYCORRECTION
    @ 100,060 MYHYPERLINK H03 VALUE "Wikipedia (https)"                     ADDRESS 'https://en.wikipedia.org/wiki/Main_Page'             WIDTH 250 HANDCURSOR MYCORRECTION
    @ 130,060 MYHYPERLINK H04 VALUE "www.hmgforum.com (www)"                ADDRESS 'www.hmgforum.com'                                    WIDTH 250 HANDCURSOR MYCORRECTION
    @ 160,060 MYHYPERLINK H05 VALUE "Wrong forum address"                   ADDRESS 'www.hmgforum1.com'                                   WIDTH 250 HANDCURSOR MYCORRECTION
    @ 190,060 MYHYPERLINK H06 VALUE "ErrorLog file (common error HMG file)" ADDRESS 'ErrorLog.Htm'                                        WIDTH 250 HANDCURSOR MYCORRECTION
    @ 220,060 MYHYPERLINK H07 VALUE "Word file"                             ADDRESS 'TEST.docx'                                           WIDTH 250 HANDCURSOR MYCORRECTION
    
    @ 102,020 IMAGE I03 PICTURE "NEW" ACTION MsgNew("https")     TRANSPARENT TOOLTIP "Click on to know more about"
    @ 132,020 IMAGE I04 PICTURE "NEW" ACTION MsgNew("www")       TRANSPARENT TOOLTIP "Click on to know more about"
    @ 162,020 IMAGE I05 PICTURE "NEW" ACTION MsgNew("wrong")     TRANSPARENT TOOLTIP "Click on to know more about"
    @ 192,020 IMAGE I06 PICTURE "NEW" ACTION MsgNew("ErrorLog")  TRANSPARENT TOOLTIP "Click on to know more about"
    @ 222,020 IMAGE I07 PICTURE "NEW" ACTION MsgNew("Word file") TRANSPARENT TOOLTIP "Click on to know more about"

    @ 010,325 FRAME Frame_2 CAPTION "LABELs" WIDTH 300 HEIGHT 280

    @ 040,360 LABEL H08 VALUE "UPU - Universal Post Union (http)"     ACTION 'http://www.upu.int/en/the-upu/member-countries.html' WIDTH 250 UNDERLINE FONTCOLOR aColorNow[nColor,1] MYCORRECTION
    @ 070,360 LABEL H09 VALUE "EMail by default engine"               ACTION 'mailto:someone@example.com'                          WIDTH 250 UNDERLINE FONTCOLOR aColorNow[nColor,1] MYCORRECTION
    @ 100,360 LABEL H10 VALUE "Wikipedia (https)"                     ACTION 'https://en.wikipedia.org/wiki/Main_Page'             WIDTH 250 UNDERLINE FONTCOLOR aColorNow[nColor,1] MYCORRECTION
    @ 130,360 LABEL H11 VALUE "www.hmgforum.com (www)"                ACTION 'www.hmgforum.com'                                    WIDTH 250 UNDERLINE FONTCOLOR aColorNow[nColor,1] MYCORRECTION
    @ 160,360 LABEL H12 VALUE "Wrong forum address"                   ACTION 'www.hmgforum1.com'                                   WIDTH 250 UNDERLINE FONTCOLOR aColorNow[nColor,1] MYCORRECTION
    @ 190,360 LABEL H13 VALUE "ErrorLog file (common error HMG file)" ACTION 'ErrorLog.Htm'                                        WIDTH 250 UNDERLINE FONTCOLOR aColorNow[nColor,1] MYCORRECTION
    @ 220,360 LABEL H14 VALUE "Word file"                             ACTION 'TEST.docx'                                           WIDTH 250 UNDERLINE FONTCOLOR aColorNow[nColor,1] MYCORRECTION
                                                                                                                                                                                                        
    @ 250,360 LABEL H15 VALUE "CodeBlock simulating HYPERLINK"        ACTION (MsgInfo('Hiperlink test message'),ChangeColor(This.Name,.F.)) WIDTH 250 UNDERLINE FONTCOLOR aColorNow[nColor,1]
    
	@ 294,240 FRAME Frame_3 CAPTION "Links color setup" WIDTH 160 HEIGHT 064
	
    @ 320,260 COMBOBOX Combo_1 ITEMS aItems VALUE 1 WIDTH 120 HEIGHT 180 ON CHANGE (nColor:=This.Value,ChangeAll()) IMAGE aImages
    
    DEFINE BUTTON Button_1
        ROW    310
        COL    90
        WIDTH  90
        HEIGHT 28
        ACTION (SetProperty("Main_form","H07","ADDRESS",'TEST.docx'))
        CAPTION "Set address"
        FONTNAME "Arial"
        FONTSIZE 9
    END BUTTON
    
    DEFINE BUTTON Button_2
        ROW    310
        COL    460
        WIDTH  90
        HEIGHT 28
        ACTION MsgDebug(GetProperty("Main_form","H08","ADDRESS"))
        CAPTION "Get Address"
        FONTNAME "Arial"
        FONTSIZE 9
    END BUTTON

END WINDOW
CENTER WINDOW Main_form

AddAllHandCursor()

ACTIVATE WINDOW Main_form
Return Nil

Function MsgNew(cOption)
LOCAL cMsg:=""
Do Case
   Case cOption="https"
        cMsg:=cMsg+"Before only http (Hypertext Transfer Protocol) was accepting as valid link address."+CRLF
        cMsg:=cMsg+"Now we have the need and opportunity to access https (Hyper Text Transfer Protocol Secure)."+CRLF
   Case cOption="www"
        cMsg:=cMsg+"Now it also accepts wwww (Now it also accepts) that is very common address."+CRLF
   Case cOption="wrong"
        cMsg:=cMsg+"Even wrong address or server out, the web navigator gives the due message."+CRLF
   Case cOption="ErrorLog"
        cMsg:=cMsg+"You can make view of ErrorLog because its has HTML format."+CRLF
   Case cOption="Word file"
        cMsg:=cMsg+"Also any text or any file can be displaying or actioned by the explorer association file."+CRLF
EndCase
MsgInfo(cMsg,"New for "+cOption)
Return Nil

Function AddAllHandCursor()
LOCAL i, cCtrl

For i=8 To 15
    cCtrl:="H"+StrZero(i,2,0)
    InitHyperLinkCursor(GetControlhandle(cCtrl,"Main_form"))
Next
Return Nil

Function MySetAddressControlProcedure(cCtrl,URL) // Here prepares a URL in CodeBlock fixing lack of _HMG_SYSDATA and add ChangeColors
LOCAL bCode, nIndex:=GetControlIndex( cCtrl, "Main_form" )

If ("@" $ URL )
   bCode := {||ShellExecute(0, "open", "rundll32.exe", "url.dll,FileProtocolHandler mailto:" + URL, ,1),ChangeColor(This.Name,.F.)}
Else
   bCode := {||ShellExecute(0, "open", "rundll32.exe", "url.dll,FileProtocolHandler " + URL, ,1),ChangeColor(This.Name,.F.)}
Endif

_HMG_SYSDATA [  6 ][nIndex] := bCode
_HMG_SYSDATA [  8 ][nIndex] := URL
Return Nil

Function ChangeColor(cCtrlName,lOn)
SetProperty("Main_form",cCtrlName,"FONTCOLOR",aColorNow[nColor,If(lOn,1,2)])
Return Nil

Function ChangeAll()
LOCAL i, cCtrl

For i=1 To 15
    cCtrl:="H"+StrZero(i,2,0)
    ChangeColor(cCtrl,.T.)
Next
Return Nil